"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = require("react");
var _utils = require("../../utils");
var _excluded = ["isMenuShown", "labelKey", "maxResults", "paginate", "text"];
function usePagination(_ref) {
  var isMenuShown = _ref.isMenuShown,
    labelKey = _ref.labelKey,
    maxResults = _ref.maxResults,
    paginate = _ref.paginate,
    text = _ref.text,
    props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  var results = (0, _toConsumableArray2["default"])(props.results);
  var _useState = (0, _react.useState)(maxResults),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    shownResults = _useState2[0],
    setShownResults = _useState2[1];

  // Reset shown results when the menu closes or the input text changes
  (0, _react.useEffect)(function () {
    setShownResults(maxResults);
  }, [isMenuShown, maxResults, text]);
  function onPaginate(e) {
    setShownResults(function (prevShownResults) {
      var _props$onPaginate;
      var newShownResults = prevShownResults + maxResults;
      (_props$onPaginate = props.onPaginate) === null || _props$onPaginate === void 0 || _props$onPaginate.call(props, e, newShownResults);
      return newShownResults;
    });
  }

  // This must come before results are truncated.
  var shouldPaginate = paginate && results.length > shownResults;
  results = (0, _utils.getTruncatedOptions)(results, shownResults);

  // Add the pagination item if necessary.
  if (shouldPaginate) {
    results.push((0, _defineProperty2["default"])((0, _defineProperty2["default"])({}, (0, _utils.getStringLabelKey)(labelKey), ''), "paginationOption", true));
  }
  return {
    onPaginate: onPaginate,
    results: results
  };
}
var _default = exports["default"] = usePagination;