import React, { forwardRef } from 'react';
import { useAsync } from '../../hooks';
import Typeahead from '../Typeahead';
const AsyncTypeahead = forwardRef((props, ref) => {
    const { emptyLabel, isLoading, promptText = 'Type to search...', searchText = 'Searching...', } = props;
    const { query, ...asyncProps } = useAsync(props);
    function getEmptyLabel() {
        if (!query.length) {
            return promptText;
        }
        if (isLoading) {
            return searchText;
        }
        return emptyLabel;
    }
    return (React.createElement(Typeahead, { ...props, ...asyncProps, emptyLabel: getEmptyLabel(), ref: ref }));
});
export default AsyncTypeahead;
