import React, { CSSProperties, InputHTMLAttributes, ReactNode } from 'react';
import { TypeaheadProps, TypeaheadRef } from '../../core';
import { RenderMenuItemChildren } from '../TypeaheadMenu';
import { MenuProps } from '../Menu';
import { Align, LabelKey, Option, OptionHandler, Size, TypeaheadInputProps, SelectEvent } from '../../types';
export type TypeaheadChildren = ReactNode | ((props: TypeaheadChildProps) => ReactNode);
export interface TypeaheadChildProps {
    getInputProps: (props?: InputHTMLAttributes<HTMLInputElement>) => Omit<TypeaheadInputProps, 'referenceElementRef'>;
    hideMenu: () => void;
    isMenuShown: boolean;
    labelKey: LabelKey;
    onClear: () => void;
    onHide: () => void;
    onRemove: OptionHandler;
    results: Option[];
    selected: Option[];
    text: string;
    toggleMenu: () => void;
}
export interface TypeaheadComponentProps extends TypeaheadProps {
    align?: Align;
    children?: TypeaheadChildren;
    className?: string;
    clearButton?: boolean;
    disabled?: boolean;
    dropup?: boolean;
    emptyLabel?: ReactNode;
    flip?: boolean;
    isInvalid?: boolean;
    isLoading?: boolean;
    isValid?: boolean;
    maxHeight?: string;
    maxResults?: number;
    newSelectionPrefix?: ReactNode;
    onPaginate?: (event: SelectEvent<HTMLElement>, shownResults: number) => void;
    options: Option[];
    paginate?: boolean;
    paginationText?: ReactNode;
    placeholder?: string;
    positionFixed?: boolean;
    renderInput?: (inputProps: TypeaheadInputProps, props: TypeaheadChildProps) => JSX.Element;
    renderMenu?: (results: Option[], menuProps: RenderMenuProps, state: TypeaheadChildProps) => JSX.Element;
    renderMenuItemChildren?: RenderMenuItemChildren;
    renderToken?: RenderToken;
    size?: Size;
    style?: CSSProperties;
}
export interface RenderMenuProps extends MenuProps {
    newSelectionPrefix?: ReactNode;
    onItemSelect: (option: Option) => void;
    paginationText?: ReactNode;
    renderMenuItemChildren?: RenderMenuItemChildren;
}
export interface RenderTokenProps {
    disabled?: boolean;
    labelKey: LabelKey;
    onRemove?: OptionHandler;
    tabIndex?: number;
}
export type RenderToken = (option: Option, props: RenderTokenProps, idx: number) => JSX.Element;
declare const Typeahead: React.ForwardRefExoticComponent<TypeaheadComponentProps & React.RefAttributes<TypeaheadRef>>;
export default Typeahead;
